req_cld2 = {}
req_cld2.requests = {}

function reqcld2(id,mode,func)
	local temp = {}
	temp.id = id
	temp.mode = mode
	temp.func = func
	req_cld2.requests[#req_cld2.requests+1] = temp
	reqcld(id,mode)
end

addhook("clientdata","req_cld2.clientdata")
function req_cld2.clientdata(id,mode,x,y)
	i = 0
	while (i < #req_cld2.requests) do
		i = i + 1
		if (id == req_cld2.requests[i].id) and (mode == req_cld2.requests[i].mode) then
			req_cld2.requests[i].func(id,x,y)
			req_cld2.requests[i] = req_cld2.requests[#req_cld2.requests]
			req_cld2.requests[#req_cld2.requests] = nil
			break
		end
	end
end

calculator = {}
calculator.data = {}
calculator.buttons = {}
calculator.press = {}
calculator.mouseover = {}
calculator.mouse = {}
calculator.calc = {}
calculator.hudtxtID1 = 1
calculator.hudtxtID2 = 2

if not(misc == nil) then
	misc.addServerTransfer("gfx/calculator/calc_background.png")
end

addhook("ms100","calculator.ms100")
function calculator.ms100()
	for id in pairs(calculator.data) do
		reqcld2(id,0,calculator.mouseHover)
	end
end

function calculator.mouseHover(id,x,y)
	if not(calculator.data[id] == nil) then
		calculator.mouse[id].x = x
		calculator.mouse[id].y = y
		local hover = 0
		i = 0
		while(i < #calculator.buttons) do
			i = i + 1			
			if (x < (640*.5)+calculator.buttons[i].x+(calculator.buttons[i].x_size*.5)) and (y < (480*.5)+calculator.buttons[i].y+(calculator.buttons[i].y_size*.5)) and (x > (640*.5)+calculator.buttons[i].x-(calculator.buttons[i].x_size*.5)) and (y > (480*.5)+calculator.buttons[i].y-(calculator.buttons[i].y_size*.5)) then
				hover = i
			end
		end
		if (hover > 0) and (calculator.mouseover[id] > 0) and (not(hover == calculator.mouseover[id])) then
			tween_color(calculator.data[id].img[calculator.mouseover[id]],100,255,255,255)
			calculator.mouseover[id] = 0
		end
		if (hover == 0) and (calculator.mouseover[id] > 0) then
			tween_color(calculator.data[id].img[calculator.mouseover[id]],100,255,255,255)
			calculator.mouseover[id] = 0
		end
		if (hover > 0) and (calculator.mouseover[id] == 0) then
			tween_color(calculator.data[id].img[hover],100,255,221,120)
			calculator.mouseover[id] = hover
		end
	end
end

addhook("attack","calculator.attack")
function calculator.attack(id)
	if not(calculator.data[id] == nil) then
		x = calculator.mouse[id].x
		y = calculator.mouse[id].y
		i = 0
		while(i < #calculator.buttons) do
			i = i + 1
			if (x < (640*.5)+calculator.buttons[i].x+(calculator.buttons[i].x_size*.5)) and (y < (480*.5)+calculator.buttons[i].y+(calculator.buttons[i].y_size*.5)) and (x > (640*.5)+calculator.buttons[i].x-(calculator.buttons[i].x_size*.5)) and (y > (480*.5)+calculator.buttons[i].y-(calculator.buttons[i].y_size*.5)) then
				calculator.buttons[i].func(id)
				calculator.processInput(id)
				if not(calculator.calc[id].text == nil) then
					parse("hudtxt2 "..id.." "..calculator.hudtxtID1.." \""..calculator.calc[id].text.."\" 400 155 2")
					if calculator.calc[id].text2 == nil then
						parse("hudtxt2 "..id.." "..calculator.hudtxtID2.." \"\" 400 140 2")
					else
						parse("hudtxt2 "..id.." "..calculator.hudtxtID2.." \""..calculator.calc[id].text2.." "..calculator.calc[id].operation.."\" 400 140 2")
					end
				end
			end
		end
		return 1
	end
end

addhook("join","calculator.join")
function calculator.join(id)
	calculator.data[id] = nil
end

addhook("say","calculator.say")
function calculator.say(id,text)
	text = string.lower(text)
	if (text == "!calc") or (text == "!calculator") then
		msg2(id,"Calculator was made by EnderCrypt (USGN: 5783)")
		if calculator.data[id] == nil then
			calculator.calc[id] = {}
			calculator.calc[id].text = "0"
			calculator.calc[id].text2 = nil
			calculator.calc[id].mem = ""
			calculator.calc[id].operation = ""
			parse("hudtxt2 "..id.." "..calculator.hudtxtID1.." \""..calculator.calc[id].text.."\" 400 155 2")
			calculator.calc[id].operation = 0
			calculator.mouse[id] = {}
			calculator.mouse[id].x = 0
			calculator.mouse[id].y = 0
			calculator.mouseover[id] = 0
			calculator.data[id] = {}
			calculator.data[id].back = image("gfx/calculator/calc_background.png",640*.5,480*.5,2,id)
			calculator.data[id].img = {}
			i = 0
			while (i < #calculator.buttons) do
				i = i + 1
				calculator.data[id].img[i] = image(calculator.buttons[i].img,(640*.5)+calculator.buttons[i].x,(480*.5)+calculator.buttons[i].y,2,id)
			end
		end
		return 1
	end
end

function calculator.addButton(img,x,y,x_size,y_size,func)
	local temp = {}
	if not(misc == nil) then
		misc.addServerTransfer(img)
	end
	temp.img = img
	temp.x = x
	temp.y = y
	temp.x_size = x_size
	temp.y_size = y_size
	temp.func = func
	calculator.buttons[#calculator.buttons+1] = temp
end

function calculator.numberOnly(id)
	local num = ""
	local i = 0
	while (i < string.len(calculator.calc[id].text)) do
		i = i + 1
		local char = string.byte(calculator.calc[id].text,i)
		if ((char > 47) and (char < 58)) then
			num = num..string.char(char)
		end
	end
	return num
end

calculator.allowedCharacters = {0,1,2,3,4,5,6,7,8,9,"-",".","?"}
temp = calculator.allowedCharacters
calculator.allowedCharacters = {}
i = 0
while (i < #temp) do
	i = i + 1
	calculator.allowedCharacters[string.byte(temp[i])] = true
end
temp = {}

function calculator.processInput(id)
	local num = ""
	local i = 0
	while (i < string.len(calculator.calc[id].text)) do
		i = i + 1
		local char = string.byte(calculator.calc[id].text,i)
		if calculator.allowedCharacters[char] then
			num = num..string.char(char)
		end
	end
	if string.byte(calculator.calc[id].text,string.len(calculator.calc[id].text)) == string.byte(".") then
		coma = true
	else
		coma = false
	end
	num = tonumber(num)
	if coma then
		num = num.."."
	end
	calculator.calc[id].text = num
end

function calculator.characterAdd(id,num)
	calculator.calc[id].text = calculator.calc[id].text..num
end

-- [close] --
function calculator.press.close(id)
	calculator.calc[id].text = ""
	parse("hudtxt2 "..id.." "..calculator.hudtxtID1.." \"\" 0 0 2")
	calculator.calc[id].text2 = nil
	parse("hudtxt2 "..id.." "..calculator.hudtxtID2.." \"\" 0 0 2")
	calculator.calc[id].operation = nil
	freeimage(calculator.data[id].back)
	i = 0
	while (i < #calculator.buttons) do
		i = i + 1
		freeimage(calculator.data[id].img[i])
	end
	calculator.data[id] = nil
end
calculator.addButton("gfx/calculator/button_close.png",88,-143,31,17,calculator.press.close)

-- [numbers] --
function calculator.press.zero(id)
	calculator.characterAdd(id,0)
end
calculator.addButton("gfx/calculator/button_0.png",-59,127,73,27,calculator.press.zero)

function calculator.press.one(id)
	calculator.characterAdd(id,1)
end
calculator.addButton("gfx/calculator/button_1.png",-78,95,34,27,calculator.press.one)

function calculator.press.two(id)
	calculator.characterAdd(id,2)
end
calculator.addButton("gfx/calculator/button_2.png",-39,95,34,27,calculator.press.two)

function calculator.press.three(id)
	calculator.characterAdd(id,3)
end
calculator.addButton("gfx/calculator/button_3.png",0,95,34,27,calculator.press.three)

function calculator.press.four(id)
	calculator.characterAdd(id,4)
end
calculator.addButton("gfx/calculator/button_4.png",-78,63,34,27,calculator.press.four)

function calculator.press.five(id)
	calculator.characterAdd(id,5)
end
calculator.addButton("gfx/calculator/button_5.png",-39,63,34,27,calculator.press.five)

function calculator.press.six(id)
	calculator.characterAdd(id,6)
end
calculator.addButton("gfx/calculator/button_6.png",0,63,34,27,calculator.press.six)

function calculator.press.seven(id)
	calculator.characterAdd(id,7)
end
calculator.addButton("gfx/calculator/button_7.png",-78,31,34,27,calculator.press.seven)

function calculator.press.eight(id)
	calculator.characterAdd(id,8)
end
calculator.addButton("gfx/calculator/button_8.png",-39,31,34,27,calculator.press.eight)

function calculator.press.nine(id)
	calculator.characterAdd(id,9)
end
calculator.addButton("gfx/calculator/button_9.png",0,31,34,27,calculator.press.nine)

function calculator.press.coma(id)
	if string.find(calculator.calc[id].text,"[.]") == nil then
		calculator.characterAdd(id,".")
	else
		msg2(id,"cant use 2 coma's")
	end
end
calculator.addButton("gfx/calculator/button_coma.png",0,127,34,27,calculator.press.coma)

-- [actions] --

-- [top] --
function calculator.press.backspace(id)
	if string.len(calculator.numberOnly(id)) == 1 then
		calculator.calc[id].text = "0"
	else
		calculator.calc[id].text = " "..string.sub(calculator.calc[id].text,1,-2)
	end
end
calculator.addButton("gfx/calculator/button_back.png",-78,-1,73,27,calculator.press.backspace)

function calculator.press.ce(id)
	calculator.calc[id].text = "0"
end
calculator.addButton("gfx/calculator/button_ce.png",-39,-1,34,27,calculator.press.ce)

function calculator.press.c(id) -- resets all
	calculator.calc[id].text = "0"
	calculator.calc[id].text2 = nil
	calculator.calc[id].operation = nil
end
calculator.addButton("gfx/calculator/button_c.png",0,-1,34,27,calculator.press.c)

function calculator.press.plusminus(id)
	if string.sub(calculator.calc[id].text,1,1) == "-" then
		calculator.calc[id].text = string.sub(calculator.calc[id].text,2)
	else
		calculator.calc[id].text = "-"..calculator.calc[id].text
		if calculator.calc[id].text == "-0" then
			calculator.calc[id].text = "0"
		end
	end
end
calculator.addButton("gfx/calculator/button_+-.png",39,-1,34,27,calculator.press.plusminus)

function calculator.press.sqrt(id)
	calculator.calc[id].text = math.sqrt(tonumber(calculator.calc[id].text))
end
calculator.addButton("gfx/calculator/button_sqrt.png",78,-1,34,27,calculator.press.sqrt)

-- [collum 1] --

function calculator.press.add(id)
	calculator.calc[id].text2 = calculator.calc[id].text
	calculator.calc[id].text = "0"
	calculator.calc[id].operation = "+"
end
calculator.addButton("gfx/calculator/button_add.png",39,127,34,27,calculator.press.add)

function calculator.press.sub(id)
	calculator.calc[id].text2 = calculator.calc[id].text
	calculator.calc[id].text = "0"
	calculator.calc[id].operation = "-"
end
calculator.addButton("gfx/calculator/button_sub.png",39,95,34,27,calculator.press.sub)

function calculator.press.mult(id)
	calculator.calc[id].text2 = calculator.calc[id].text
	calculator.calc[id].text = "0"
	calculator.calc[id].operation = "*"
end
calculator.addButton("gfx/calculator/button_mult.png",39,63,34,27,calculator.press.mult)

function calculator.press.div(id)
	calculator.calc[id].text2 = calculator.calc[id].text
	calculator.calc[id].text = "0"
	calculator.calc[id].operation = "/"
end
calculator.addButton("gfx/calculator/button_div.png",39,31,34,27,calculator.press.div)

-- [collum 2] --

function calculator.press.equal(id)
	if not(calculator.calc[id].text2 == nil) then
		if calculator.calc[id].operation == "+" then
			calculator.calc[id].text = calculator.calc[id].text2+calculator.calc[id].text
		end
		if calculator.calc[id].operation == "-" then
			calculator.calc[id].text = calculator.calc[id].text2-calculator.calc[id].text
		end
		if calculator.calc[id].operation == "*" then
			calculator.calc[id].text = calculator.calc[id].text2*calculator.calc[id].text
		end
		if calculator.calc[id].operation == "/" then
			calculator.calc[id].text = calculator.calc[id].text2/calculator.calc[id].text
		end
		calculator.calc[id].text2 = nil
		calculator.calc[id].operation = nil
	end
end
calculator.addButton("gfx/calculator/button_equal.png",78,111,34,59,calculator.press.equal)

function calculator.press.onex(id)
	calculator.calc[id].text = 1 / tonumber(calculator.calc[id].text)
end
calculator.addButton("gfx/calculator/button_1x.png",78,63,34,27,calculator.press.onex)

function calculator.press.percent(id)
	calculator.calc[id].text = tonumber(calculator.calc[id].text) / 100
end
calculator.addButton("gfx/calculator/button_%.png",78,31,34,27,calculator.press.percent)
